from collections import deque

n, m, k = map(int, input().split())
adj_list = [[] for _ in range(n + 1)]
for _ in range(m):
    a, b = map(int, input().split())
    adj_list[a].append(b)
    adj_list[b].append(a)

guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))

visited = [False] * (n + 1)
protected = set()


def bfs(start, stamina):
    visited[start] = True
    queue = deque([(start, 0)])

    while queue:
        node, dist = queue.popleft()

        if dist > stamina:
            continue

        protected.add(node)

        for neighbor in adj_list[node]:
            if not visited[neighbor]:
                visited[neighbor] = True
                queue.append((neighbor, dist + 1))


for guard in guards:
    p, h = guard
    bfs(p, h)

print(len(protected))
print(" ".join(map(str, sorted(protected))))