from collections import deque, defaultdict


def bfs(start, max_distance, graph):
    visited = set()
    queue = deque([(start, 0)]) 
    visited.add(start)

    while queue:
        current, distance = queue.popleft()
        if distance < max_distance:
            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, distance + 1))

    return visited


def main():
    n, m, k = map(int, input().split())

    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for _ in range(k):
        p, h = map(int, input().split())
        guarded.update(bfs(p, h, graph))

    guarded = sorted(guarded)
    print(len(guarded))
    if guarded:
        print(" ".join(map(str, guarded)))
    else:
        print()

if __name__ == "__main__":
    main()

